Index: trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/testutil/DummyUsabilityGuidlineDescriptionResolver.java
===================================================================
--- trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/testutil/DummyUsabilityGuidlineDescriptionResolver.java	(revision 1036)
+++ trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/testutil/DummyUsabilityGuidlineDescriptionResolver.java	(revision 1040)
@@ -1,2 +1,16 @@
+//   Copyright 2012 Georg-August-Universität Göttingen, Germany
+//
+//   Licensed under the Apache License, Version 2.0 (the "License");
+//   you may not use this file except in compliance with the License.
+//   You may obtain a copy of the License at
+//
+//       http://www.apache.org/licenses/LICENSE-2.0
+//
+//   Unless required by applicable law or agreed to in writing, software
+//   distributed under the License is distributed on an "AS IS" BASIS,
+//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+//   See the License for the specific language governing permissions and
+//   limitations under the License.
+
 package de.ugoe.cs.autoquest.usability.testutil;
 
@@ -5,5 +19,14 @@
 import de.ugoe.cs.autoquest.usability.evaluation.rule.set.UsabilityRule;
 
-public class DummyUsabilityGuidlineDescriptionResolver implements UsabilityDefectDescriptionResolver {
+/**
+ * <p>
+ * TODO comment
+ * </p>
+ * 
+ * @author Alexander Deicke
+ */
+public class DummyUsabilityGuidlineDescriptionResolver implements
+    UsabilityDefectDescriptionResolver
+{
 
     public DefectDescription descriptionFor(UsabilityRule usabilityRule) {
Index: trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/testutil/DummyUsabilityRuleset.java
===================================================================
--- trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/testutil/DummyUsabilityRuleset.java	(revision 1036)
+++ trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/testutil/DummyUsabilityRuleset.java	(revision 1040)
@@ -1,2 +1,16 @@
+//   Copyright 2012 Georg-August-Universität Göttingen, Germany
+//
+//   Licensed under the Apache License, Version 2.0 (the "License");
+//   you may not use this file except in compliance with the License.
+//   You may obtain a copy of the License at
+//
+//       http://www.apache.org/licenses/LICENSE-2.0
+//
+//   Unless required by applicable law or agreed to in writing, software
+//   distributed under the License is distributed on an "AS IS" BASIS,
+//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+//   See the License for the specific language governing permissions and
+//   limitations under the License.
+
 package de.ugoe.cs.autoquest.usability.testutil;
 
@@ -13,14 +27,24 @@
 import de.ugoe.cs.autoquest.usability.evaluation.rule.set.UsabilityRuleset;
 
+/**
+ * <p>
+ * TODO comment
+ * </p>
+ * 
+ * @author Alexander Deicke
+ */
 public class DummyUsabilityRuleset implements UsabilityRuleset {
 
     private enum DummyUsabilityRule implements UsabilityRule {
-        
+
         DUMMY_RULE_WITH_RECOMMENDATION {
-            
+
             @Override
             public Optional<UsabilityDefect> evaluate(ITaskTree taskTree) {
-                return Optional.of(new UsabilityDefectFactory(new DummyUsabilityGuidlineDescriptionResolver()).
-                                   createUsabilityGuidlineRecommendation(UsabilityDefectSeverityLevel.INFO, this, Collections.<String, String> emptyMap()));
+                return Optional
+                    .of(new UsabilityDefectFactory(new DummyUsabilityGuidlineDescriptionResolver())
+                        .createUsabilityGuidlineRecommendation(UsabilityDefectSeverityLevel.INFO,
+                                                               this, Collections
+                                                                   .<String, String> emptyMap()));
             }
 
@@ -28,9 +52,9 @@
                 return this.name();
             }
-            
+
         },
-        
+
         DUMMY_RULE_WITHOUT_RECOMMENDATION {
-            
+
             @Override
             public Optional<UsabilityDefect> evaluate(ITaskTree taskTree) {
@@ -46,7 +70,7 @@
 
     }
-    
-    private final EnumSet<DummyUsabilityRule> DUMMY_USABILITY_RULESET = 
-            EnumSet.allOf(DummyUsabilityRule.class);
+
+    private final EnumSet<DummyUsabilityRule> DUMMY_USABILITY_RULESET = EnumSet
+        .allOf(DummyUsabilityRule.class);
 
     public EnumSet<? extends UsabilityRule> evaluationRules() {
Index: trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/testutil/FestConditionUtil.java
===================================================================
--- trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/testutil/FestConditionUtil.java	(revision 1036)
+++ trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/testutil/FestConditionUtil.java	(revision 1040)
@@ -1,2 +1,16 @@
+//   Copyright 2012 Georg-August-Universität Göttingen, Germany
+//
+//   Licensed under the Apache License, Version 2.0 (the "License");
+//   you may not use this file except in compliance with the License.
+//   You may obtain a copy of the License at
+//
+//       http://www.apache.org/licenses/LICENSE-2.0
+//
+//   Unless required by applicable law or agreed to in writing, software
+//   distributed under the License is distributed on an "AS IS" BASIS,
+//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+//   See the License for the specific language governing permissions and
+//   limitations under the License.
+
 package de.ugoe.cs.autoquest.usability.testutil;
 
@@ -10,4 +24,11 @@
 import de.ugoe.cs.autoquest.usability.evaluation.rule.set.UsabilityRuleset;
 
+/**
+ * <p>
+ * TODO comment
+ * </p>
+ * 
+ * @author Alexander Deicke
+ */
 public class FestConditionUtil {
 
@@ -15,8 +36,8 @@
         // no good idea
     }
-    
+
     public static Condition<UsabilityEvaluationReport> noUsabilityGuidlineRecommendations() {
         return new Condition<UsabilityEvaluationReport>() {
-    
+
             @Override
             public boolean matches(UsabilityEvaluationReport usabilityEvaluationReport) {
@@ -25,8 +46,8 @@
         };
     }
-    
+
     public static Condition<UsabilityEvaluationReport> usabilityGuidlineRecommendations() {
         return new Condition<UsabilityEvaluationReport>() {
-    
+
             @Override
             public boolean matches(UsabilityEvaluationReport usabilityEvaluationReport) {
@@ -35,5 +56,5 @@
         };
     }
-    
+
     public static Condition<UsabilityRuleset> noUsabilityRules() {
         return new Condition<UsabilityRuleset>() {
@@ -43,9 +64,8 @@
                 return usabilityRuleset.evaluationRules().isEmpty();
             }
-    
 
         };
     }
-    
+
     public static Condition<UsabilityRuleset> usabilityRules() {
         return new Condition<UsabilityRuleset>() {
@@ -55,9 +75,8 @@
                 return !usabilityRuleset.evaluationRules().isEmpty();
             }
-    
 
         };
     }
-    
+
     public static Condition<Optional<UsabilityDefect>> present() {
         return new Condition<Optional<UsabilityDefect>>() {
@@ -67,8 +86,8 @@
                 return usabilityGuidlineRecommendation.isPresent();
             }
-    
+
         };
     }
-    
+
     public static Condition<Optional<UsabilityDefect>> absent() {
         return new Condition<Optional<UsabilityDefect>>() {
@@ -78,8 +97,8 @@
                 return !usabilityGuidlineRecommendation.isPresent();
             }
-    
+
         };
     }
-    
+
     public static Condition<Optional<UsabilityDefect>> infoRecommendationSeverityLevel() {
         return new Condition<Optional<UsabilityDefect>>() {
@@ -87,10 +106,11 @@
             @Override
             public boolean matches(Optional<UsabilityDefect> usabilityGuidlineRecommendation) {
-                return usabilityGuidlineRecommendation.get().getSeverityLevel().equals(UsabilityDefectSeverityLevel.INFO);
+                return usabilityGuidlineRecommendation.get().getSeverityLevel()
+                    .equals(UsabilityDefectSeverityLevel.INFO);
             }
 
         };
     }
-    
+
     public static Condition<Optional<UsabilityDefect>> lowRecommendationSeverityLevel() {
         return new Condition<Optional<UsabilityDefect>>() {
@@ -98,10 +118,11 @@
             @Override
             public boolean matches(Optional<UsabilityDefect> usabilityGuidlineRecommendation) {
-                return usabilityGuidlineRecommendation.get().getSeverityLevel().equals(UsabilityDefectSeverityLevel.LOW);
+                return usabilityGuidlineRecommendation.get().getSeverityLevel()
+                    .equals(UsabilityDefectSeverityLevel.LOW);
             }
 
         };
     }
-    
+
     public static Condition<Optional<UsabilityDefect>> mediumRecommendationSeverityLevel() {
         return new Condition<Optional<UsabilityDefect>>() {
@@ -109,10 +130,11 @@
             @Override
             public boolean matches(Optional<UsabilityDefect> usabilityGuidlineRecommendation) {
-                return usabilityGuidlineRecommendation.get().getSeverityLevel().equals(UsabilityDefectSeverityLevel.MEDIUM);
+                return usabilityGuidlineRecommendation.get().getSeverityLevel()
+                    .equals(UsabilityDefectSeverityLevel.MEDIUM);
             }
 
         };
     }
-    
+
     public static Condition<Optional<UsabilityDefect>> highRecommendationSeverityLevel() {
         return new Condition<Optional<UsabilityDefect>>() {
@@ -120,9 +142,10 @@
             @Override
             public boolean matches(Optional<UsabilityDefect> usabilityGuidlineRecommendation) {
-                return usabilityGuidlineRecommendation.get().getSeverityLevel().equals(UsabilityDefectSeverityLevel.HIGH);
+                return usabilityGuidlineRecommendation.get().getSeverityLevel()
+                    .equals(UsabilityDefectSeverityLevel.HIGH);
             }
 
         };
     }
-    
+
 }
Index: trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/testutil/GenerateTaskTreeUtil.java
===================================================================
--- trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/testutil/GenerateTaskTreeUtil.java	(revision 1036)
+++ trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/testutil/GenerateTaskTreeUtil.java	(revision 1040)
@@ -1,2 +1,15 @@
+//   Copyright 2012 Georg-August-Universität Göttingen, Germany
+//
+//   Licensed under the Apache License, Version 2.0 (the "License");
+//   you may not use this file except in compliance with the License.
+//   You may obtain a copy of the License at
+//
+//       http://www.apache.org/licenses/LICENSE-2.0
+//
+//   Unless required by applicable law or agreed to in writing, software
+//   distributed under the License is distributed on an "AS IS" BASIS,
+//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+//   See the License for the specific language governing permissions and
+//   limitations under the License.
 
 package de.ugoe.cs.autoquest.usability.testutil;
@@ -17,6 +30,13 @@
 import de.ugoe.cs.util.console.TextConsole;
 
+/**
+ * <p>
+ * TODO comment
+ * </p>
+ * 
+ * @author Alexander Deicke
+ */
 public class GenerateTaskTreeUtil {
-    
+
     private static final String seqName = "sequences";
 
Index: trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/testutil/TaskTreeBuilder.java
===================================================================
--- trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/testutil/TaskTreeBuilder.java	(revision 1036)
+++ trunk/autoquest-core-usability-evaluation-test/src/main/java/de/ugoe/cs/autoquest/usability/testutil/TaskTreeBuilder.java	(revision 1040)
@@ -1,2 +1,16 @@
+//   Copyright 2012 Georg-August-Universität Göttingen, Germany
+//
+//   Licensed under the Apache License, Version 2.0 (the "License");
+//   you may not use this file except in compliance with the License.
+//   You may obtain a copy of the License at
+//
+//       http://www.apache.org/licenses/LICENSE-2.0
+//
+//   Unless required by applicable law or agreed to in writing, software
+//   distributed under the License is distributed on an "AS IS" BASIS,
+//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+//   See the License for the specific language governing permissions and
+//   limitations under the License.
+
 package de.ugoe.cs.autoquest.usability.testutil;
 
@@ -6,22 +20,29 @@
 import de.ugoe.cs.autoquest.tasktrees.treeimpl.TaskTreeNodeFactory;
 
+/**
+ * <p>
+ * TODO comment
+ * </p>
+ * 
+ * @author Alexander Deicke
+ */
 public class TaskTreeBuilder {
-    
+
     public static CreateRootNodeStep builder() {
         return new CreateRootNodeStep();
     }
-    
+
     public static class CreateRootNodeStep {
-        
+
         public AddChildrenStep root(String name) {
             return new AddChildrenStep(new TaskTreeNode(name));
         }
-        
+
     }
-    
+
     public static class AddChildrenStep {
-        
+
         private TaskTreeNode rootNode;
-        
+
         public AddChildrenStep(TaskTreeNode taskTreeRootNode) {
             this.rootNode = taskTreeRootNode;
@@ -32,56 +53,57 @@
             return this;
         }
-        
+
         public ITaskTree creatTaskTree() {
             return new TaskTreeNodeFactory().createTaskTree(rootNode);
         }
-        
+
     }
-    
-//        private Employee employee;
-//
-//        public EmployeeBuilder() {
-//            employee = new Employee();
-//        }
-//
-//        public static EmployeeBuilder defaultValues() {
-//            return new EmployeeBuilder();
-//        }
-//
-//        public static EmployeeBuilder clone(Employee toClone) {
-//            EmployeeBuilder builder = defaultValues();
-//            builder.setId(toClone.getId());
-//            builder.setName(toClone.getName());
-//            builder.setDepartment(toClone.getDepartment());
-//            return builder;
-//        }
-//
-//        public static EmployeeBuilder random() {
-//            EmployeeBuilder builder = defaultValues();
-//            builder.setId(getRandomInteger(0, 1000));
-//            builder.setName(getRandomString(20));
-//            builder.setDepartment(Department.values()[getRandomInteger(0, Department.values().length - 1)]);
-//            return builder;
-//        }
-//
-//        public EmployeeBuilder setId(int id) {
-//            employee.setId(id);
-//            return this;
-//        }
-//
-//        public EmployeeBuilder setName(String name) {
-//            employee.setName(name);
-//            return this;
-//        }
-//
-//        public EmployeeBuilder setDepartment(Department dept) {
-//            employee.setDepartment(dept);
-//            return this;
-//        }
-//
-//        public Employee build() {
-//            return employee;
-//        }
-//    }
+
+    // private Employee employee;
+    //
+    // public EmployeeBuilder() {
+    // employee = new Employee();
+    // }
+    //
+    // public static EmployeeBuilder defaultValues() {
+    // return new EmployeeBuilder();
+    // }
+    //
+    // public static EmployeeBuilder clone(Employee toClone) {
+    // EmployeeBuilder builder = defaultValues();
+    // builder.setId(toClone.getId());
+    // builder.setName(toClone.getName());
+    // builder.setDepartment(toClone.getDepartment());
+    // return builder;
+    // }
+    //
+    // public static EmployeeBuilder random() {
+    // EmployeeBuilder builder = defaultValues();
+    // builder.setId(getRandomInteger(0, 1000));
+    // builder.setName(getRandomString(20));
+    // builder.setDepartment(Department.values()[getRandomInteger(0, Department.values().length -
+    // 1)]);
+    // return builder;
+    // }
+    //
+    // public EmployeeBuilder setId(int id) {
+    // employee.setId(id);
+    // return this;
+    // }
+    //
+    // public EmployeeBuilder setName(String name) {
+    // employee.setName(name);
+    // return this;
+    // }
+    //
+    // public EmployeeBuilder setDepartment(Department dept) {
+    // employee.setDepartment(dept);
+    // return this;
+    // }
+    //
+    // public Employee build() {
+    // return employee;
+    // }
+    // }
 
 }