Index: trunk/autoquest-core-tasktrees-test/src/test/java/de/ugoe/cs/autoquest/tasktrees/temporalrelation/TrackBarSelectionDetectionRuleTest.java
===================================================================
--- trunk/autoquest-core-tasktrees-test/src/test/java/de/ugoe/cs/autoquest/tasktrees/temporalrelation/TrackBarSelectionDetectionRuleTest.java	(revision 974)
+++ trunk/autoquest-core-tasktrees-test/src/test/java/de/ugoe/cs/autoquest/tasktrees/temporalrelation/TrackBarSelectionDetectionRuleTest.java	(revision 1106)
@@ -46,52 +46,52 @@
              "    }" +
              "  }" +
-             "}", getTaskTree());
-
-        simulateEvent(new ValueSelection<Integer>(2), element1);
-        new TaskTreeChecker().assertTaskTree
-            ("Sequence sequence1 {" +
-             "  Iteration iteration1 {" +
-             "    Selection selection1 {" +
-             "      Event ValueSelection(\"1\") {}" +
-             "      Event ValueSelection(\"2\") {}" +
-             "    }" +
-             "  }" +
-             "}", getTaskTree());
-
-        simulateEvent(new ValueSelection<Integer>(3), element1);
-        new TaskTreeChecker().assertTaskTree
-            ("Sequence sequence1 {" +
-             "  Iteration iteration1 {" +
-             "    Selection selection1 {" +
-             "      Event ValueSelection(\"1\") {}" +
-             "      Event ValueSelection(\"2\") {}" +
-             "      Event ValueSelection(\"3\") {}" +
-             "    }" +
-             "  }" +
-             "}", getTaskTree());
-
-        simulateEvent(new ValueSelection<Integer>(2), element1);
-        new TaskTreeChecker().assertTaskTree
-            ("Sequence sequence1 {" +
-             "  Iteration iteration1 {" +
-             "    Selection selection1 {" +
-             "      Event ValueSelection(\"1\") {}" +
-             "      Event ValueSelection(\"2\") {}" +
-             "      Event ValueSelection(\"3\") {}" +
-             "    }" +
-             "  }" +
-             "}", getTaskTree());
-
-        simulateEvent(new ValueSelection<Integer>(3), element1);
-        new TaskTreeChecker().assertTaskTree
-            ("Sequence sequence1 {" +
-             "  Iteration iteration1 {" +
-             "    Selection selection1 {" +
-             "      Event ValueSelection(\"1\") {}" +
-             "      Event ValueSelection(\"2\") {}" +
-             "      Event ValueSelection(\"3\") {}" +
-             "    }" +
-             "  }" +
-             "}", getTaskTree());
+             "}", getTaskTree(TrackBarSelectionDetectionRule.class, null));
+
+        simulateEvent(new ValueSelection<Integer>(2), element1);
+        new TaskTreeChecker().assertTaskTree
+            ("Sequence sequence1 {" +
+             "  Iteration iteration1 {" +
+             "    Selection selection1 {" +
+             "      Event ValueSelection(\"1\") {}" +
+             "      Event ValueSelection(\"2\") {}" +
+             "    }" +
+             "  }" +
+             "}", getTaskTree(TrackBarSelectionDetectionRule.class, null));
+
+        simulateEvent(new ValueSelection<Integer>(3), element1);
+        new TaskTreeChecker().assertTaskTree
+            ("Sequence sequence1 {" +
+             "  Iteration iteration1 {" +
+             "    Selection selection1 {" +
+             "      Event ValueSelection(\"1\") {}" +
+             "      Event ValueSelection(\"2\") {}" +
+             "      Event ValueSelection(\"3\") {}" +
+             "    }" +
+             "  }" +
+             "}", getTaskTree(TrackBarSelectionDetectionRule.class, null));
+
+        simulateEvent(new ValueSelection<Integer>(2), element1);
+        new TaskTreeChecker().assertTaskTree
+            ("Sequence sequence1 {" +
+             "  Iteration iteration1 {" +
+             "    Selection selection1 {" +
+             "      Event ValueSelection(\"1\") {}" +
+             "      Event ValueSelection(\"2\") {}" +
+             "      Event ValueSelection(\"3\") {}" +
+             "    }" +
+             "  }" +
+             "}", getTaskTree(TrackBarSelectionDetectionRule.class, null));
+
+        simulateEvent(new ValueSelection<Integer>(3), element1);
+        new TaskTreeChecker().assertTaskTree
+            ("Sequence sequence1 {" +
+             "  Iteration iteration1 {" +
+             "    Selection selection1 {" +
+             "      Event ValueSelection(\"1\") {}" +
+             "      Event ValueSelection(\"2\") {}" +
+             "      Event ValueSelection(\"3\") {}" +
+             "    }" +
+             "  }" +
+             "}", getTaskTree(TrackBarSelectionDetectionRule.class, null));
 
     }
@@ -151,5 +151,5 @@
              "    }" +
              "  }" +
-             "}", getTaskTree());
+             "}", getTaskTree(TrackBarSelectionDetectionRule.class, null));
     }
 
@@ -176,25 +176,28 @@
             ("Sequence sequence1 {" +
              "  Iteration iteration1 {" +
-             "    Sequence sequence2 {" +
-             "      Sequence sequence3 {" +
-             "        Iteration iteration2 {" +
-             "          Selection selection1 {" +
-             "            Event ValueSelection(\"1\") {}" +
-             "            Event ValueSelection(\"3\") {}" +
-             "            Event ValueSelection(\"2\") {}" +
-             "          }" +
-             "        }" +
-             "      }" +
-             "      Sequence sequence4 {" +
-             "        Iteration iteration3 {" +
-             "          Selection selection2 {" +
-             "            Event ValueSelection(\"2\") {}" +
-             "            Event ValueSelection(\"1\") {}" +
-             "          }" +
-             "        }" +
-             "      }" +
-             "    }" +
-             "  }" +
-             "}", getTaskTree());
+             "    Selection selection1 {" +
+             "      Event ValueSelection(\"1\") {}" +
+             "      Event ValueSelection(\"2\") {}" +
+             "      Event ValueSelection(\"3\") {}" +
+             "    }" +
+             "  }" +
+             "  Iteration iteration2 {" +
+             "    Selection selection2 {" +
+             "      Event ValueSelection(\"2\") {}" +
+             "      Event ValueSelection(\"1\") {}" +
+             "    }" +
+             "  }" +
+             "  Iteration iteration3 {" +
+             "    Selection selection3 {" +
+             "      Event ValueSelection(\"3\") {}" +
+             "      Event ValueSelection(\"2\") {}" +
+             "    }" +
+             "  }" +
+             "  Iteration iteration4 {" +
+             "    Selection selection4 {" +
+             "      Event ValueSelection(\"1\") {}" +
+             "    }" +
+             "  }" +
+             "}", getTaskTree(TrackBarSelectionDetectionRule.class, null));
     }
 